<template>
  <el-form
    v-if="!allowTheme"
    ref="formRuleRef"
    v-loading="isProcessing"
    :label-position="positionLabel || labelPosition"
    label-width="140px"
    :rules="formRule"
    :model="apiRequest"
  >
    <el-form-item :label="$t('redeemable')">
      <h4 class="fc-text">{{ redeemableModelForDisplay }}</h4>
    </el-form-item>
    <el-form-item :label="$t('redeem_amount')" prop="Amount">
      <el-input
        v-model="apiRequest.Amount"
        :placeholder="redeemableModel"
        :controls="false"
      />
    </el-form-item>
    <div class="mt-3 flex justify-end">
      <el-button round type="primary" @click="onSubmit(formRuleRef)">{{
        $t("submit")
      }}</el-button>
    </div>
  </el-form>
  <el-form
    v-else
    ref="formRuleRef"
    v-loading="isProcessing"
    :label-position="positionLabel || labelPosition"
    label-width="140px"
    :rules="formRule"
    :model="apiRequest"
    class="py-[15px] px-3"
  >
    <el-form-item :label="$t('redeemable')">
      <h4 class="fc-secondary text-sm font-bold leading-4 text-center">
        {{ redeemableModel }}
      </h4>
    </el-form-item>
    <el-form-item :label="$t('redeem_amount')" prop="Amount">
      <el-input
        v-model="apiRequest.Amount"
        class="input-refferral"
        :placeholder="redeemableModel"
        :controls="false"
      />
    </el-form-item>
    <div class="w-full flex justify-center mt-4">
      <el-button round type="primary" class="submit-referral">{{
        $t("submit")
      }}</el-button>
    </div>
  </el-form>
</template>
<script lang="ts">
import { computed, defineComponent } from "vue";
import { store } from "@/store";

export default defineComponent({
  name: "ReferralModel",
  props: {
    positionLabel: {
      type: String,
      default: "",
    },
  },
  setup() {
    const {
      dialogVisible,
      labelPosition,
      submitRequest,
      apiRequest,
      formRule,
      redeemableModel,
      redeemableModelForDisplay,
      onCloseDialog,
      formRuleRef,
      isProcessing,
      onSubmit,
    } = useReferralModel();
    const allowTheme = computed(() => store.state.selectedThemeName === "main");
    return {
      dialogVisible,
      labelPosition,
      onCloseDialog,
      submitRequest,
      apiRequest,
      formRule,
      redeemableModel,
      redeemableModelForDisplay,
      formRuleRef,
      isProcessing,
      onSubmit,
      allowTheme,
    };
  },
});
</script>
<style lang="scss">
.redeem-dialog .el-form--label-top {
  padding: 12px;
}
[theme-color="bk8"] {
  .input-refferral .el-input__inner {
    color: var(--primary);
  }
  .submit-referral {
    min-width: 152px;
    height: 40px;
  }
}
</style>
<style scoped lang="scss">
:deep(.el-form-item.asterisk-left) {
  margin-bottom: 0;
}
[theme-color="bk8"] .fc-secondary {
  padding-bottom: 12px;
  padding-top: 4px;
}
[theme-color="peru_green"] {
  .fc-text {
    color: var(--primary) !important;
  }
  .input-refferral .el-input__inner {
    color: var(--text5);
  }
}
</style>
